/*****************************************************************************
 * CSE142, 98 Autumn                                                         *
 * Homework 4                                                                *
 * Rain Gods and Goddesses                                                   *
 * Chau, Tu                                                                  *
 * Section AH                                                                *
 * #ID 9833407                                                               *
 ****************************************************************************/
 /*
  STARTER PROGRAM

  To start with, your job is to figure out what this program does.
 *
 *
 */

 /* There's a landscape in the background...

 */

#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	10

/*color of letter on buttons*/
#define SELECTED_COLOR   YELLOW	 
#define UNSELECTED_COLOW BLACK

#define MAX_PRECIP_EVENTS	500
	/*This is the total number of drops possible at one time.*/

/* y-ccordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))


/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0

/* Types of precipitations we support */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define HAIL 3

/*if you add new types of percip, you may need to change this*/
#define MAX_PRECIP_TYPES 3

/*Possible places for mouse clicks*/
#define BUTTON 1
	/*The above means you clicked on SOME button (doesn't say which one yet)*/
#define DIRT 2
	/*The above means you clicked in the dirt area */
#define SPEED_RAIN  4
#define SPEED_SNOW  3
#define SPEED_HAIL  5
#define SPEED_TRAIN 5
#define SPEED_CAR   6
#define SPEED_WIND  10

/*******************  FUNCTION PROTOTYPES ***********************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/
void DrawButtons(int current_precip, int current_color);

/*Clear all percipitation, so the landscape is just as originally*/

void DrawAllPrecipitation(int kind_array[MAX_PRECIP_EVENTS],
						  int x_array[MAX_PRECIP_EVENTS],
						  int y_array[MAX_PRECIP_EVENTS],
						  int color_array[MAX_PRECIP_EVENTS]);

/*render (draw) all the precipitation*/

/* draw the house */
void DrawHouse();
/* draw the tree  */
void DrawTree();
/* draw the train */
void DrawTrain(int train_x);
/* draw landscape */
void DrawLandscape();

/*draw one drop     */
void DrawPrecipColumn(int precip_type, int bottom_x, int bottom_y, int color);
/* Draw 1 rain drop */
void DrawRainDrop (int x, int y, int color);
/* Draw 1 snow drop */
void DrawSnowDrop (int x, int y, int color);
/* Draw 1 hail drop */
void DrawHailDrop (int x, int y, int color);
/* draw the  road and the car */
void Draw_road_car(int car_x, int car1_x,int color, int color1);
/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
			 int* wind, int* tornado, int *light, int *clear_weather);
/* initialize all elements of all arrays with number 0 */
void assign (int kind_array [],int color_array[], int x_array[],
				 int y_array[]);
 /* clear all elements of all arrays*/
void ClearAll (int kind_array [], int color_array[],
				  int x_array[], int y_array[]);
/* Clear some elements of arrays */
void light_up_pre (int kind_array [], int color_array[],
				  int x_array[], int y_array[]);
/* assign variable mouse_x, mouse_y, current_color, precip_type
in to arrays */
void assign_values ( int kind_array[], int x_array[],
                     int y_array[], int color_array[], int current_precip,
                     int current_color, int x, int y);
/* move all elements of arrays into first positions*/
void organize ( int kind_array[], int x_array[],
					  int y_array[], int color_array[], int *count );
/* create new rain drops, or snow drops, or hall drops */
void generator ( int kind_array[], int x_array[],
					  int y_array[], int color_array[], int count );
/* make rain drops, snow drops, hail drop can move back and forth */
void chang_position( int kind_array[], int x_array[],
					  int y_array[], int color_array[]);
/* make the wind */
void make_wind(  int kind_array[], int x_array[], int y_array[],
					  int color_array[], int number);
/* make tornado */
void make_tornado (int kind_array[], int x_array[], int y_array[],
			  int color_array[], double angle);
/******************************************************************************

     MAIN

/******************************************************************************/

	/* main() has two chief purposes: to contain the important variables and 
	initialize them,
	and to contain the "event loop," which constantly looks to see if an event has
	happened, and then processes the event by calling an appropriate function.
	*/
int main(void)
{
  int quit = FALSE;
  int mouse_x, mouse_y, mouse1_x, mouse1_y;
  char key_hit, key_hit1;
 /* initialize some value */
  int sun_x =GP142_XMAX - 50, sun_y = GP142_YMAX - 35;
  int train_x = GP142_XMAX;/* begin x_coordinator of the train */
  int car_x = -GP142_XMAX-40; /* begin x_coordinator of the car */
  int car1_x = GP142_XMAX+40; /* begin x_coordinator of another car */
  int color= RED;             /* begin corlor of the car */
  int color1 = GREEN;         /* begin color of another car */
  int x_message =  -GP142_XMAX-40;
  int x_message1 = GP142_XMAX + 40;
  int y_message =  -GP142_YMAX-20;
  int y_message1= GP142_YMAX+20;
   /* The next itens tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */
  int kind_array[MAX_PRECIP_EVENTS];
  int color_array[MAX_PRECIP_EVENTS];
  int x_array[MAX_PRECIP_EVENTS];
  int y_array[MAX_PRECIP_EVENTS];
  int count,r;
  double angle;
  int current_precip = NONE, current_color = NONE; /*what to draw next */
  
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;
  int wind = FALSE;
  int tornado=FALSE;
  int done = FALSE;
  /*what kind of click was there?*/
  int mouse_click;
  int number=0;/* this number for change the wind direction */
  int event; /*the most recent GP142 event*/
  int light;/* variable for light up */

  time_t t; /*needed only when initializing a random number generator*/

  /*
   * INITIALIZATIONS
   */
   
    
  srand (time(&t));	      /* Seed the random number generator             */
		/*This is something you should do if you plan to use random numbers.
		Put it here in your program and forget about it.
		*/

  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */
  
  GP142_rectangleXY(BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
  /* this loop is openning message */
  while(!done){
  event = GP142_await_event(&mouse1_x, &mouse1_y, &key_hit1);
  switch (event) {
  case GP142_QUIT:
	done=TRUE;
	quit=TRUE;
  break;
  case GP142_KBD:
  break;
  case GP142_MOUSE:
   if(mouse1_x<GP142_XMAX-250 && mouse1_y<GP142_YMAX-300
	  && mouse1_x>GP142_XMAX-400 && mouse1_y > GP142_YMAX-350)
    done = TRUE;
   break;
  case GP142_PERIODIC:
	 
/* up date the coordinators of the message */	  
     x_message = x_message + 10;
     x_message1= x_message1 - 10;
	 if(x_message > GP142_XMAX-340)
	  x_message =GP142_XMAX-340;
	 if(x_message1 < GP142_XMAX-560)
	  x_message1=GP142_XMAX-560;
	 GP142_rectangleXY(BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
/* draw the message */
     GP142_printfXY (RED,x_message, GP142_YMAX-200,30,
     " MY HOME LAND.");
      GP142_printfXY (RED,x_message1, GP142_YMAX-200,30,
     " WELCOME TO"); 
	  y_message = y_message + 5;
      y_message1= y_message1 - 5;
	 
	 if(y_message >GP142_YMAX-250 )
	  y_message =GP142_YMAX-250;
	 if (y_message1 < GP142_YMAX-250)
	  y_message1=GP142_YMAX-250;
/* draw the information of the author */
	  GP142_printfXY (RED, GP142_XMAX-280,y_message ,30,
      " ID# 9833407 ");
      GP142_printfXY (RED, GP142_XMAX-580,y_message1 ,30,
     " AUTHOR: TU CHAU");
	  GP142_rectangleXY(YELLOW, GP142_XMAX-250, GP142_YMAX-300,
		    GP142_XMAX-400, GP142_YMAX-350, FILL);
      GP142_printfXY (RED, GP142_XMAX-350,GP142_YMAX-320 ,10,
     "CLICK");
	  GP142_printfXY (RED, GP142_XMAX-375,GP142_YMAX-350 ,25,
     "ENTER");

  

  break;
  default:
  break;
  }/* end the switch */
   
  }/* end the loop */
  
  
  
  
  DrawLandscape();
  DrawHouse();
  DrawTree();
  DrawTrain(train_x);
  Draw_road_car(car_x, car1_x,color,color1);
  DrawButtons(current_precip, current_color);	  /* Show the buttons...*/ 

 /* call assign to assign all elements of arrays equal 0 */ 
  assign ( kind_array , color_array, x_array, y_array);
  
   


  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  

  while (!quit) {  /*this is the famous "event loop" */

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop */
      break;

    case GP142_KBD:
		/*not needed for this program.*/
		/*Use this if user will need to hit a key.
		/*Note that scanf CANNOT be used with GP142*/
      break;

    case GP142_MOUSE:
		/* a mouse click has occurred. */
        /* check for button versus dirt */
        /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == BUTTON) {
			/* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color,&wind,&tornado,&light,&clear_flag);
		if (clear_flag)
        {
          wind =FALSE;
          tornado =FALSE;
          ClearAll (kind_array, color_array, x_array,  y_array);	
        }
        if (wind)
        {
		tornado = FALSE;
        number=0;
		}
        if (tornado)
		{ wind = FALSE;
		angle =0;}
		if(light)
		light_up_pre (kind_array, color_array,
               x_array,  y_array);
	} else if ((mouse_click != DIRT)
		/*it's not a button, and it's not the dirt, so it must be sky*/
		&& 
		 (current_precip != NONE) && (current_color != NONE))
         assign_values (kind_array, x_array,
                      y_array, color_array, current_precip,
                      current_color, mouse_x, mouse_y);

      
      break;

    case GP142_PERIODIC:
      	/*Some time has passed, 
		so make all the precipitation a little lower*/
		/* change the snow drop's position a little bit */
	organize (kind_array, x_array,
               y_array, color_array, &count );	
	generator ( kind_array, x_array,
                y_array, color_array, count );
        

        if (!wind && ! tornado)
        chang_position(kind_array,x_array,
                 y_array, color_array);
        if (wind)
        make_wind(kind_array, x_array, y_array, color_array,number);
        number=number+1;/* up date the number */
        if( number>80)
        number=0;
        

	   /* change the the position of the train */
		 train_x=train_x-SPEED_TRAIN;
		if (train_x < -GP142_XMAX -380)
			 train_x=GP142_XMAX;

		/*and change the sun's position a little bit*/
		sun_x --;
		if (sun_x < -GP142_XMAX -30) {
			sun_x = - sun_x;
			sun_y = sun_y -1;
				/* over a long period of time, the sun will set.*/
	
		}
         car_x =car_x+SPEED_CAR;
        if (car_x > GP142_XMAX +30) {
			car_x =-GP142_XMAX -30 ;
		    r=rand();
			if(r%23!=22)
             color = r%23;}
        car1_x =car1_x-SPEED_CAR;
		if (car1_x < -GP142_XMAX -30) {
			car1_x = GP142_XMAX +30;
            r=rand();
			if(r%23!=22)
                color1 = r%23;}
		if(tornado)
		{
	    chang_position(kind_array,x_array,
                 y_array, color_array);   
		make_tornado (kind_array, x_array, y_array, color_array,  angle);
		angle = angle+3.14/8;
		}


     break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw everything */
	DrawLandscape(sun_x, sun_y);
	DrawHouse();
	DrawTree();
	DrawTrain(train_x);
	Draw_road_car( car_x, car1_x, color,  color1);
	DrawButtons(current_precip, current_color);
	DrawAllPrecipitation(kind_array, x_array, y_array, color_array);

  }  /* end event loop */

  


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */

/****************************************************************************

     FUNCTIONS

*****************************************************************************/

/* draw the 1 drop of rain*/
#define RAINDROP_WIDTH 3
void DrawRainDrop (int x, int y, int color)
{
	if(color==BLUE)
    GP142_circleXY(BLUE,x,y,RAINDROP_WIDTH);
	else if(color==WHITE)
    GP142_circleXY(WHITE,x,y,RAINDROP_WIDTH);
	else
    GP142_circleXY(YELLOW,x,y,RAINDROP_WIDTH);
} /* end the DrawRainDrop function */

/****************************************************************************/
/* draw the 1 drop of snow */
#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 5
  void DrawSnowDrop (int x, int y, int color) {
	if(color==BLUE)
    GP142_triangleXY(BLUE,x,y,x+SNOWDROP_WIDTH,y,x,y+SNOWDROP_HEIGHT,FILL);
    else if(color==WHITE)
    GP142_triangleXY(WHITE,x,y,x+SNOWDROP_WIDTH,y,x,y+SNOWDROP_HEIGHT,FILL);
    else
	 GP142_triangleXY(YELLOW,x,y,x+SNOWDROP_WIDTH,y,x,y+SNOWDROP_HEIGHT,FILL);
}/* end the DrawSnowDrop function */

/****************************************************************************/
/* draw the 1 drop of hail */
#define HAILDROP_WIDTH 4
  void DrawHailDrop (int x, int y, int color){
    if(color==BLUE)
    GP142_rectangleXY(BLUE,x,y,x+HAILDROP_WIDTH,y+HAILDROP_WIDTH,FILL);
    else if(color==WHITE)
    GP142_rectangleXY(WHITE,x,y,x+HAILDROP_WIDTH,y+HAILDROP_WIDTH,FILL);
	else
    GP142_rectangleXY(YELLOW,x,y,x+SNOWDROP_WIDTH,y+SNOWDROP_WIDTH,FILL);
} /* end the DrawHailDrop function */

/***************************************************************************/
void DrawAllPrecipitation(int kind_array[MAX_PRECIP_EVENTS], 
						  int x_array[MAX_PRECIP_EVENTS],
						  int y_array[MAX_PRECIP_EVENTS],
						  int color_array[MAX_PRECIP_EVENTS])
{
	int i;
	for (i=0; i<MAX_PRECIP_EVENTS;i++){
	    if(kind_array[i]!=0){
    	if (y_array[i] >= TOP_OF_DIRT - 20) {
		switch (kind_array[i]) {
		case RAIN:
			DrawRainDrop (x_array[i], y_array[i], color_array[i]);
			break;
		case SNOW:
			DrawSnowDrop (x_array[i], y_array[i], color_array[i]);
			break;
		case HAIL:
			DrawHailDrop (x_array[i], y_array[i], color_array[i]);
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/
			
	}
	}}

}
/***********************************************************************/
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;

}

/*************************************************************************/
void DrawLandscape(int sun_x, int sun_y)
{  
int text_offset = -GP142_XMAX + 15, font_size = 12;


  /* Draw the sky first */
  GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
 
  /* Draw the sun */
  GP142_circleXY(YELLOW, sun_x, sun_y , 20);

  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
    /*Draw the mountains */
  GP142_triangleXY(MED_GRAY,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);

  GP142_triangleXY(OLIVE,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);

} /*end DrawLandscape */

/*************************************************************************/
/* Draw the house */
void DrawHouse (void)
{
  /* Draw the top of the house */
  GP142_triangleXY(PINK, -GP142_XMAX+150, TOP_OF_DIRT+104,
	           -GP142_XMAX+95, TOP_OF_DIRT+62, -GP142_XMAX+205,
			   TOP_OF_DIRT+62, FILL);
  GP142_lineXY(RED, -GP142_XMAX+104,TOP_OF_DIRT+60,
				-GP142_XMAX+196, TOP_OF_DIRT+60,3);

  /* Draw the body of the house*/
  GP142_rectangleXY(PURPLE, -GP142_XMAX+104, TOP_OF_DIRT+59,
			 -GP142_XMAX+196, TOP_OF_DIRT, FILL);

  /* Draw the window */
  GP142_rectangleXY(WHITE, -GP142_XMAX+115, TOP_OF_DIRT+48,
		    -GP142_XMAX+140, TOP_OF_DIRT+14, FILL);
  GP142_rectangleXY(BLACK, -GP142_XMAX+115, TOP_OF_DIRT+48,
		    -GP142_XMAX+140, TOP_OF_DIRT+14, 2);
  GP142_lineXY(BLACK, -GP142_XMAX+127,TOP_OF_DIRT+48, 
            -GP142_XMAX+127, TOP_OF_DIRT+14,3);
  GP142_lineXY(BLACK, -GP142_XMAX+115,TOP_OF_DIRT+31, 
				-GP142_XMAX+140, TOP_OF_DIRT+31,3);
  /* Draw the main door */
  GP142_rectangleXY(GOLD, -GP142_XMAX+151, TOP_OF_DIRT+48,
			 -GP142_XMAX+180, TOP_OF_DIRT, FILL);
  GP142_circleXY(BLUE,-GP142_XMAX+155,TOP_OF_DIRT+24,2);

  } /* End the DrawHouse function */

/************************************************************************/
/* Draw the tree */
void DrawTree(void)
{
 int x1,y1, x2,y2; /* x1, y1 are the start point's coordinator of the line,
 x2,y2 are the end point's coordinator of the line */
 x1=GP142_XMAX-190;
 y1=TOP_OF_DIRT+43;
 x2=GP142_XMAX-90;
 y2=TOP_OF_DIRT+43;
 GP142_rectangleXY(MED_GRAY,GP142_XMAX-130,TOP_OF_DIRT+40,GP142_XMAX-150,
              TOP_OF_DIRT,FILL);

 /* This loop draw many lines to create the body of the tree */
   while(x1<=160)
   {
    GP142_lineXY(GREEN,x1,y1, x2,y2,4);
    x1=x1+2;
    y1=y1+5;
    x2=x2-2;
    y2=y2+5;
   }/*end the while loop */

}/* End the drawtree function */

/*************************************************************************/

 /* Draw the train */
#define BODY_TRAIN   5
#define SMOKE_NUMBER 3
void DrawTrain(int train_x)
{
int x1,x2,i;  /* x-coordinator of start point and end point of a line */
int temp;     /* The initial value of train_x */
int smoke,x;  /* The y and x coordinator of a smoke */

/* initializations values */
  smoke=TOP_OF_DIRT+13;
  temp=train_x;
  x1=GP142_XMAX;
  x2=GP142_XMAX;

/* draw the road */
 GP142_lineXY(BLACK, GP142_XMAX,TOP_OF_DIRT-26,
				-GP142_XMAX, TOP_OF_DIRT-26,3);
 GP142_lineXY(BLACK, GP142_XMAX,TOP_OF_DIRT-16,
				-GP142_XMAX, TOP_OF_DIRT-16,3);
 while(x1>=-GP142_XMAX){
  GP142_lineXY(BLACK,x1,TOP_OF_DIRT-16,x2,TOP_OF_DIRT-26,3);
  x1=x1-10;
  x2=x2-10;
	}/*end the while loop */

/* Draw the body of the train */
 for (i=1;i<=BODY_TRAIN;i++)
 {

   GP142_rectangleXY(i+1,train_x, TOP_OF_DIRT+2,
			   train_x+60, TOP_OF_DIRT-18, FILL);
   train_x=train_x+80;/* up date value train_x */
     
   }/* end the for loop*/
 /* Draw the wheels */
	train_x=temp;
  for (i=0;i<=2*BODY_TRAIN-1;i++)
  {
  GP142_circleXY(BLACK,train_x+10,TOP_OF_DIRT-22,4);
  GP142_circleXY(WHITE,train_x+10,TOP_OF_DIRT-22,2);
  train_x=train_x+40; /* up date value train_x */
  }/*end the for loop */

  /* Draw the line to connect two small part of the train */
  train_x=temp;
  for(i=0;i<BODY_TRAIN-1;i++)
  {
  GP142_lineXY(BLACK, train_x+60,TOP_OF_DIRT-8,
				train_x+80, TOP_OF_DIRT-8,2);
  train_x=train_x+80; /* up date value train_x */
  }/*end the for loop*/
 
  train_x=temp;
  GP142_rectangleXY(BLACK,train_x+8, TOP_OF_DIRT+2,
			       train_x+12, TOP_OF_DIRT+10, FILL);
 /* Draw smoke */
   x=train_x+9;
  for(i=0;i<SMOKE_NUMBER;i++)
  {
  GP142_circleXY(BLACK,x,smoke,1);
  smoke = smoke+4;
  x=x+4;/* up date value smoke */
  }/*end the for loop */
} /* end the drawtrain function */

/***************************************************************/
void Draw_road_car(int car_x, int car1_x,int color, int color1)
{
/* initialize the start points of some line to construct the road */
  int text_offset = -GP142_XMAX + 15, font_size = 12;
  int x1, x2,a,b;
  x1=GP142_XMAX;
  x2=GP142_XMAX;
  a=GP142_XMAX;
  b=GP142_XMAX;

/* Draw the road */
GP142_lineXY(BLACK,GP142_XMAX,TOP_OF_DIRT-50,
				-GP142_XMAX, TOP_OF_DIRT-50,2);
GP142_lineXY(BLACK,GP142_XMAX,TOP_OF_DIRT-46,
				-GP142_XMAX, TOP_OF_DIRT-46,2);
GP142_lineXY(BLACK,GP142_XMAX,TOP_OF_DIRT-86,
				-GP142_XMAX, TOP_OF_DIRT-86,2);
GP142_lineXY(BLACK,GP142_XMAX,TOP_OF_DIRT-82,
				-GP142_XMAX, TOP_OF_DIRT-82,2);
GP142_rectangleXY(MED_GRAY,GP142_XMAX,TOP_OF_DIRT-51,-GP142_XMAX,
              TOP_OF_DIRT-82,FILL);
GP142_rectangleXY(BLUE,GP142_XMAX,TOP_OF_DIRT-88,-GP142_XMAX,
				  -GP142_YMAX,FILL);

/* Draw some small lines to construct the road */
while(x1>=-GP142_XMAX){
  GP142_lineXY(RED,x1,TOP_OF_DIRT-50,x2,TOP_OF_DIRT-46,1);
  GP142_lineXY(RED,x1,TOP_OF_DIRT-86,x2,TOP_OF_DIRT-82,1);
  GP142_lineXY(YELLOW,b,TOP_OF_DIRT-88,
				b, TOP_OF_DIRT-98,4);
   GP142_lineXY(DUSTY_PLUM,b,TOP_OF_DIRT-28,
				b, TOP_OF_DIRT-38,4);

  GP142_lineXY(YELLOW,a,TOP_OF_DIRT-64,
				a-10, TOP_OF_DIRT-64,1);
	b=b-28;
  a=a-25;
  x1=x1-5;
  x2=x2-5;
}/* End the while loop */
/* Draw the car */
GP142_rectangleXY(color1,car1_x+20,TOP_OF_DIRT-38,car1_x-10,
              TOP_OF_DIRT-48,FILL);
GP142_rectangleXY(color1,car1_x+20,TOP_OF_DIRT-48,car1_x-20,
              TOP_OF_DIRT-58,FILL);
GP142_circleXY(BLACK,car1_x-10,TOP_OF_DIRT-58,4);
GP142_circleXY(BLACK,car1_x+10,TOP_OF_DIRT-58,4);

GP142_rectangleXY(color,car_x+10,TOP_OF_DIRT-56,car_x-20,
              TOP_OF_DIRT-66,FILL);
GP142_rectangleXY(color,car_x+20,TOP_OF_DIRT-66,car_x-20,
              TOP_OF_DIRT-76,FILL);
GP142_circleXY(BLACK,car_x-10,TOP_OF_DIRT-76,4);
GP142_circleXY(BLACK,car_x+10,TOP_OF_DIRT-76,4);
/* draw the message */
GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");
} /* End the function draw_road_car */
 /* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		    int *wind, int *tornado, int *light, int *clear_weather)
{
  int max_speed = 80;
  int buttonNum = 0;
  *light = FALSE;
  *wind  = FALSE;
  *tornado= FALSE;
  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  case 2:
    *current_precip = HAIL;
    break;
  case 3:
    *current_color = WHITE;
    break;
  case 4:
    *current_color = BLUE;
    break;
  case 5:
    *current_color = YELLOW;
    break;
  case 6:
    *wind=TRUE;
    break;
  case 7:
    *tornado=TRUE;
	break;
  case 8:
	*light = TRUE;
	break;
  case 9:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}


/*********************************************************/
/* Draws the buttons */
void DrawButtons(int current_precip, int current_color)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Snow");
  
  i -= BUTTON_HEIGHT;
  if (current_precip == HAIL)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Hail");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Hail");
  
 
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Blue");
    
  i -= BUTTON_HEIGHT;
  if (current_color == YELLOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Yellow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Yellow");
     i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Wind"); 
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Tornado");
    i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Light up");
  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");

}

/************************************************************/
void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}
/************************************************************/
void assign ( int kind_array [], int color_array[],
              int x_array[], int y_array[])
  {
    int i;
    for(i=0;i<MAX_PRECIP_EVENTS;i++)
    {
	kind_array[i]=0;
	color_array[i]=0;
	x_array[i]=0;
	y_array[i]=0;
	 } /* end the for loop */
  }/* End the function */

/*******************************************************/
 void ClearAll (int kind_array [], int color_array[],
              int x_array[], int y_array[])

 {  int i;
	for(i=0;i < MAX_PRECIP_EVENTS;i++)
		{kind_array[i] = 0;
		 x_array[i] = 0;
		 y_array[i] = 0;
		 color_array[i] =0;
	 }/* end the for loop */
 }/* End the function clearAll */
/********************************************************/
 void light_up_pre (int kind_array [], int color_array[],
              int x_array[], int y_array[])
 {
 int i, r_number;
	  for(i=0; i<MAX_PRECIP_EVENTS; i++)
     {
			 if(i%5==0){
		   r_number=rand();
		  kind_array[r_number%MAX_PRECIP_EVENTS] = 0;
		 x_array[r_number%MAX_PRECIP_EVENTS] = 0;
		 y_array[r_number%MAX_PRECIP_EVENTS] = 0;
		 color_array[r_number%MAX_PRECIP_EVENTS] =0;}
	  } /* end the for loop */
  } /* End the function light_up */

/*************************************************************/
 void assign_values ( int kind_array[], int x_array[],
                     int y_array[], int color_array[], int current_precip,
                     int current_color, int x, int y)
 {     
       int i;

         for(i=0;i<MAX_PRECIP_EVENTS;i++){
		 if(kind_array[i]==0){
		 kind_array[i] = current_precip;
		 x_array[i] = x;
		 y_array[i] = y;
		 color_array[i] = current_color;
		 i=MAX_PRECIP_EVENTS;
		}}/* end the for loop */
 }/* end the function */

/************************************************************************/
 void organize ( int kind_array[], int x_array[],
                 int y_array[], int color_array[], int *count )
{     int i;
		*count = 0;
		for(i=0;i<MAX_PRECIP_EVENTS;i++)
		{
			if(kind_array[i]!=0)
			{
			  kind_array[*count]=kind_array[i];
			  color_array[*count]=color_array[i];
			  x_array[*count]=x_array[i];
			  y_array[*count]=y_array[i];
			  if(*count!=i)
			  {
			  kind_array[i]=0;
			  color_array[i]=0;
			  x_array[i]=0;
			  y_array[i]=0;
			  }
			*count = *count+1;
			}
		}/* End the for loop */
} /* end the function */

/***********************************************************************/
void generator ( int kind_array[], int x_array[],
                 int y_array[], int color_array[], int count )
{
    int r_number;
    int h;
    int i;
	 r_number = rand();
	 h= r_number%(count+1);
	 if(r_number/200>150)
  {
	 for(i=0;i<MAX_PRECIP_EVENTS;i++)
	 {
		if(kind_array[i]==0)
		  {
		  kind_array[i]=kind_array[h];
		  color_array[i]=color_array[h];
		  if((r_number%20)%2==0)
				x_array[i]=x_array[h]-(r_number%20);
		  else
            x_array[i]=x_array[h]+(r_number%20);
		  y_array[i]=GP142_YMAX;
		  i=MAX_PRECIP_EVENTS;
		  }
	  }/* end the for loop */
  } /* end the if */

}/* end the function */

/*********************************************************************/


void chang_position( int kind_array[], int x_array[],
                 int y_array[], int color_array[])

{
  int i, r_number;
  for(i=0;i<MAX_PRECIP_EVENTS;i++)
  {
	  if(kind_array[i]!=0)
	  {
			r_number=rand();
			/* change the positions of snows litle bit */
			if(kind_array[i] == SNOW)
			  {
			  y_array[i] = y_array[i] - SPEED_SNOW;
			  if(r_number%4==0)
			  x_array[i]=x_array[i]-3;
			  if(r_number%4==1)
			  x_array[i]=x_array[i]+3;
			  }

		  /* change the rain drop's position a little bit */
		  else if(kind_array[i] ==RAIN)
			 {
			 y_array[i] = y_array[i] - SPEED_RAIN;
			 if(r_number%5==0)
				x_array[i]=x_array[i]-2;
			 if(r_number%5==1)
			 x_array[i]=x_array[i]+2;
			 }

        /* change the hail drop's position a little bit */
		  else
			{
			y_array[i] = y_array[i] - SPEED_HAIL;

			if(r_number%5==0)
			 x_array[i]=x_array[i]-1;
			if(r_number%5==1)
		    x_array[i]=x_array[i]+1;
			 }


		 if(y_array[i] < TOP_OF_DIRT-20)
			y_array[i] = GP142_YMAX;
     }

	  else
      i= MAX_PRECIP_EVENTS;
  }
}
/*****************************************************************************/

void make_wind( int kind_array[], int x_array[], int y_array[],
							      int color_array[], int number)
{
int i;
int random;

if(number<=40)
{
      
   for (i =0; i<MAX_PRECIP_EVENTS; i++)
   {
       if(kind_array[i]!=0) 
       { 
       x_array[i]=x_array[i]+SPEED_WIND;
       y_array[i]=y_array[i]-SPEED_WIND;
      
	       if (y_array[i]<=TOP_OF_DIRT-20||x_array[i]>=GP142_XMAX)
		   {
	          random=rand();
              if (random%2==0)
			  {
              x_array[i]=-GP142_XMAX;
              y_array[i]=GP142_YMAX-random%150;
			  }
	          else
			  {
		      x_array[i]=-GP142_XMAX+random%150;
              y_array[i]=GP142_YMAX;
			  }
		   }
		 }/* end the if statement */
		else
     i=MAX_PRECIP_EVENTS;
	} /* end the for loop */
}/* end the big if */

else
 { 
	for (i =0; i<MAX_PRECIP_EVENTS; i++)
	{
      if(kind_array[i]!=0) 
      { 
      x_array[i]=x_array[i]-SPEED_WIND;
      y_array[i]=y_array[i]-SPEED_WIND;
      
	      if (y_array[i]<=TOP_OF_DIRT-20||x_array[i]<=-GP142_XMAX)
		  {
	         random=rand();
             if (random%2==0)
			 {
             x_array[i]=GP142_XMAX;
             y_array[i]=GP142_YMAX-random%150;
			 }
	         else
			 {
		     x_array[i]=GP142_XMAX-random%150;
             y_array[i]=GP142_YMAX;
			 }
		  }
	  }
     else
     i=MAX_PRECIP_EVENTS;
 
	} /* end the for loop */
 } /* end else */
} /* end the function */

/**************************************************************************************/
void make_tornado (int kind_array[], int x_array[], int y_array[],
						 int color_array[] , double angle)
{    
       int i, random;
          for(i=0;i<500;i++){
             if (kind_array[i]!=0){
		     x_array[i] = x_array[i]+(int)(20*sin(angle));
             y_array[i] = y_array[i]+(int)(20*cos(angle));
			    if (x_array[i]>=GP142_XMAX||x_array[i]<=-GP142_XMAX||
				               y_array[i]>=GP142_YMAX)
				{
	            random=rand();
			    x_array[i]=-GP142_XMAX+random%300;
			    y_array[i]= GP142_YMAX-random%100;
				}
			 }
			 else
			 i= MAX_PRECIP_EVENTS;
		 }/* End the for loop */
        

}/* End the function */










